--- hash.c.orig	2009-07-19 22:46:18.000000000 -0800
+++ hash.c	2009-07-19 22:46:13.000000000 -0800
@@ -67,12 +67,16 @@
                close(fd);
                fatal(__FUNCTION__);
        }
-       buf = mmap(NULL, stats.st_size, PROT_READ, MAP_PRIVATE, fd, 0); 
-       if (buf == MAP_FAILED) {
-               cc_log("Failed to mmap %s\n", fname);
-               close(fd);
-               fatal(__FUNCTION__);
-        }       
+       if( stats.st_size == 0 )
+	       buf = NULL;
+       else {
+	       buf = mmap(NULL, stats.st_size, PROT_READ, MAP_PRIVATE, fd, 0); 
+	       if (buf == MAP_FAILED) {
+		       cc_log("Failed to mmap %s\n", fname);
+		       close(fd);
+		       fatal(__FUNCTION__);
+		}       
+       }
 
         hash_buffer(buf, stats.st_size);
 	close(fd);